diff --git a/lib/nvmf/transport.c b/lib/nvmf/transport.c
index a261b565aa7..ab7e6a7739a 100644
--- a/lib/nvmf/transport.c
+++ b/lib/nvmf/transport.c
@@ -410,7 +410,7 @@ nvmf_stop_listen_disconnect_qpairs(struct spdk_io_channel_iter *i)
 		}
 
 		if (!spdk_nvme_transport_id_compare(&ctx->trid, &tmp_trid)) {
-			if (ctx->subsystem == NULL ||
+			if (ctx->subsystem == NULL || qpair->ctrlr == NULL ||
 			    ctx->subsystem == qpair->ctrlr->subsys) {
 				spdk_nvmf_qpair_disconnect(qpair, NULL, NULL);
 			}
